package com.landray.kmss.sys.attachment.thirdSfs.util;

import com.landray.kmss.framework.plugin.core.config.IExtension;
import com.landray.kmss.framework.plugin.core.config.IExtensionPoint;
import com.landray.kmss.framework.service.plugin.Plugin;
import java.util.Iterator;
import com.sun.istack.NotNull;
import java.util.ArrayList;
import java.util.List;

public class SysAttThirdJspUtil
{
    private static List<ThirdJspPlugin> thirdJspPlugins;
    
    static {
        SysAttThirdJspUtil.thirdJspPlugins = new ArrayList<ThirdJspPlugin>();
    }
    
    public static String getViewUrl(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getViewUrl();
    }
    
    public static String getEditUrl(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getEditUrl();
    }
    
    public static String getViewOLUrl(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getViewOLUrl();
    }
    
    public static String getEditOLUrl(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getEditOLUrl();
    }
    
    public static String getViewUrl4M(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getViewUrl4M();
    }
    
    public static String getEditUrl4M(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getEditUrl4M();
    }
    
    public static String getViewOLUrl4M(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getViewOLUrl4M();
    }
    
    public static String getEditOLUrl4M(@NotNull final String key) {
        final ThirdJspPlugin plugin = getThirdJspPlugin(key);
        if (plugin == null) {
            return null;
        }
        return plugin.getEditOLUrl4M();
    }
    
    private static ThirdJspPlugin getThirdJspPlugin(final String key) {
        final List<ThirdJspPlugin> thirdJspPlugins = getThirdJspPlugins();
        for (final ThirdJspPlugin p : thirdJspPlugins) {
            if (p.getKey().equals(key)) {
                return p;
            }
        }
        return null;
    }
    
    private static List<ThirdJspPlugin> getThirdJspPlugins() {
        if (SysAttThirdJspUtil.thirdJspPlugins.isEmpty()) {
            synchronized (SysAttThirdJspUtil.thirdJspPlugins) {
                if (SysAttThirdJspUtil.thirdJspPlugins.isEmpty()) {
                    final IExtensionPoint point = Plugin.getExtensionPoint("com.landray.kmss.sys.attachment.third.sfs.jsp");
                    final IExtension[] extensions = point.getExtensions();
                    IExtension[] array;
                    for (int length = (array = extensions).length, i = 0; i < length; ++i) {
                        final IExtension extension = array[i];
                        if ("config".equals(extension.getAttribute("name"))) {
                            final String key = Plugin.getParamValueString(extension, "key");
                            final String name = Plugin.getParamValueString(extension, "name");
                            final String viewUrl = Plugin.getParamValueString(extension, "viewUrl");
                            final String editUrl = Plugin.getParamValueString(extension, "editUrl");
                            final String viewOLUrl = Plugin.getParamValueString(extension, "viewOLUrl");
                            final String editOLUrl = Plugin.getParamValueString(extension, "editOLUrl");
                            final String viewUrl4M = Plugin.getParamValueString(extension, "viewUrl4M");
                            final String editUrl4M = Plugin.getParamValueString(extension, "editUrl4M");
                            final String viewOLUrl4M = Plugin.getParamValueString(extension, "viewOLUrl4M");
                            final String editOLUrl4M = Plugin.getParamValueString(extension, "editOLUrl4M");
                            SysAttThirdJspUtil.thirdJspPlugins.add(new ThirdJspPlugin(key, name, viewUrl, editUrl, viewOLUrl, editOLUrl, viewUrl4M, editUrl4M, viewOLUrl4M, editOLUrl4M));
                        }
                    }
                }
                monitorexit(SysAttThirdJspUtil.thirdJspPlugins);
            }
        }
        return SysAttThirdJspUtil.thirdJspPlugins;
    }
    
    static class ThirdJspPlugin
    {
        private String key;
        private String name;
        private String viewUrl;
        private String editUrl;
        private String viewOLUrl;
        private String editOLUrl;
        private String viewUrl4M;
        private String editUrl4M;
        private String viewOLUrl4M;
        private String editOLUrl4M;
        
        public ThirdJspPlugin(final String key, final String name, final String viewUrl, final String editUrl, final String viewOLUrl, final String editOLUrl, final String viewUrl4M, final String editUrl4M, final String viewOLUrl4M, final String editOLUrl4M) {
            this.key = key;
            this.name = name;
            this.viewUrl = viewUrl;
            this.editUrl = editUrl;
            this.viewOLUrl = viewOLUrl;
            this.editOLUrl = editOLUrl;
            this.viewUrl4M = viewUrl4M;
            this.editUrl4M = editUrl4M;
            this.viewOLUrl4M = viewOLUrl4M;
            this.editOLUrl4M = editOLUrl4M;
        }
        
        public String getKey() {
            return this.key;
        }
        
        public String getName() {
            return this.name;
        }
        
        public String getViewUrl() {
            return this.viewUrl;
        }
        
        public String getEditUrl() {
            return this.editUrl;
        }
        
        public String getViewOLUrl() {
            return this.viewOLUrl;
        }
        
        public String getEditOLUrl() {
            return this.editOLUrl;
        }
        
        public String getViewUrl4M() {
            return this.viewUrl4M;
        }
        
        public String getEditUrl4M() {
            return this.editUrl4M;
        }
        
        public String getViewOLUrl4M() {
            return this.viewOLUrl4M;
        }
        
        public String getEditOLUrl4M() {
            return this.editOLUrl4M;
        }
    }
}
